<?php
//=========================================================================================\\
// Copyright (C) WTStats.info, All rights reserved.	 http://www.wtstats.info			   \\
//=========================================================================================\\
if (!defined('ATSPHP')) {
  die("This file cannot be accessed directly.");
}

class settings extends base {
  function settings() {
    global $CONF, $DB, $FORM, $LNG, $TMPL;

    $TMPL['header'] = $LNG['a_s_header'];

    if (!isset($FORM['submit'])) {
      $this->form();
    }
    else {
      $this->process();
    }
  }

	function form() {
		global $CONF, $DB, $LNG, $TMPL;

		$languages_menu = '';
		$languages = array();
		$dir = opendir("{$CONF['path']}/languages/");
		while (false !== ($file = readdir($dir))) {
			$file = str_replace('.php', '', $file);
			if(is_file("{$CONF['path']}/languages/{$file}.php")) {
				require "{$CONF['path']}/languages/{$file}.php";
				$languages[$file] = $translation;
			}
		}
		natcasesort($languages);
		foreach ($languages as $file => $translation) {
			if($file == $CONF['default_language']) 
			{$languages_menu .= "<option value=\"{$file}\" selected=\"selected\">{$translation}</option>\n";}
			else 
			{$languages_menu .= "<option value=\"{$file}\">{$translation}</option>\n";}
		}
		require "{$CONF['path']}/languages/{$CONF['default_language']}.php";

		$ranking_period_menu = '';
		$ranking_periods = array('daily', 'weekly', 'monthly', 'overall');
		foreach ($ranking_periods as $ranking_period) {
			if ($ranking_period == $CONF['ranking_period']) { $ranking_period_menu .= "<option value=\"$ranking_period\" selected=\"selected\">{$LNG["g_{$ranking_period}"]}</option>\n"; }
			else { $ranking_period_menu .= "<option value=\"$ranking_period\">{$LNG["g_{$ranking_period}"]}</option>\n"; }
		}

		if($CONF['ranking_average']) 
		{$ranking_average_menu = "<option value=\"1\" selected=\"selected\">{$LNG['g_average']}</option>\n<option value=\"0\">{$LNG['g_this_period']}</option>\n";} 
		else 
		{$ranking_average_menu = "<option value=\"1\">{$LNG['g_average']}</option>\n<option value=\"0\" selected=\"selected\">{$LNG['g_this_period']}</option>\n";}
		$LNG['a_s_ranking_average'] = sprintf($LNG['a_s_ranking_average'], strtolower($LNG['g_this_period']));

		if($CONF['search']) 
		{$search_menu = "<option value=\"1\" selected=\"selected\">{$LNG['a_s_on']}</option>\n<option value=\"0\">{$LNG['a_s_off']}</option>\n";} 
		else 
		{$search_menu = "<option value=\"1\">{$LNG['a_s_on']}</option>\n<option value=\"0\" selected=\"selected\">{$LNG['a_s_off']}</option>\n";}

		if(!$CONF['active_default']) 
		{$active_default_menu = "<option value=\"0\" selected=\"selected\">{$LNG['a_s_on']}</option>\n<option value=\"1\">{$LNG['a_s_off']}</option>\n";} 
		else 
		{$active_default_menu = "<option value=\"0\">{$LNG['a_s_on']}</option>\n<option value=\"1\" selected=\"selected\">{$LNG['a_s_off']}</option>\n";}

		if(!$CONF['active_default_review']) 
		{$active_default_review_menu = "<option value=\"0\" selected=\"selected\">{$LNG['a_s_on']}</option>\n<option value=\"1\">{$LNG['a_s_off']}</option>\n";}
		else 
		{$active_default_review_menu = "<option value=\"0\">{$LNG['a_s_on']}</option>\n<option value=\"1\" selected=\"selected\">{$LNG['a_s_off']}</option>\n";}

		if($CONF['email_admin_on_join']) 
		{$email_admin_on_join_menu = "<option value=\"1\" selected=\"selected\">{$LNG['a_s_on']}</option>\n<option value=\"0\">{$LNG['a_s_off']}</option>\n";}
		else 
		{$email_admin_on_join_menu = "<option value=\"1\">{$LNG['a_s_on']}</option>\n<option value=\"0\" selected=\"selected\">{$LNG['a_s_off']}</option>\n";}

		if($CONF['email_admin_on_review']) 
		{$email_admin_on_review_menu = "<option value=\"1\" selected=\"selected\">{$LNG['a_s_on']}</option>\n<option value=\"0\">{$LNG['a_s_off']}</option>\n";}
		else 
		{$email_admin_on_review_menu = "<option value=\"1\">{$LNG['a_s_on']}</option>\n<option value=\"0\" selected=\"selected\">{$LNG['a_s_off']}</option>\n";}

		$TMPL['admin_content'] = <<<EndHTML
<form action="index.php?a=admin&amp;b=settings" method="post">
<fieldset>
<legend>{$LNG['a_s_general']}</legend>
<label>{$LNG['a_s_list_name']}<br />
<input type="text" name="list_name" size="50" value="{$CONF['list_name']}" /><br /><br />
</label>
<label>{$LNG['a_s_list_url']}<br />
<input type="text" name="list_url" size="50" value="{$CONF['list_url']}" /><br /><br />
</label>
<label>{$LNG['a_s_default_language']}<br />
<select name="default_language">
{$languages_menu}</select><br /><br />
</label>
<label>{$LNG['a_s_your_email']}<br />
<input type="text" name="your_email" size="50" value="{$CONF['your_email']}" />
</label>
</fieldset>

<fieldset>
<legend>{$LNG['a_s_ranking']}</legend>
<label>{$LNG['a_s_num_list']}<br />
<input type="text" name="num_list" size="5" value="{$CONF['num_list']}" /><br /><br />
</label>
<label>{$LNG['a_s_ranking_period']}<br />
<select name="ranking_period">
{$ranking_period_menu}</select><br /><br />
</label>
<label>{$LNG['a_s_ranking_average']}<br />
<select name="ranking_average">
{$ranking_average_menu}</select><br /><br />
</label>
</fieldset>

<fieldset>
<legend>{$LNG['a_s_member']}</legend>
<label>{$LNG['a_s_active_default']}<br />
<select name="active_default">
{$active_default_menu}</select><br /><br />
</label>
<label>{$LNG['a_s_active_default_review']}<br />
<select name="active_default_review">
{$active_default_review_menu}</select><br /><br />
</label>
<label>{$LNG['a_s_delete_after']}<br />
<input type="text" name="delete_after" size="5" value="{$CONF['delete_after']}" /><br /><br />
</label>
<label>{$LNG['a_s_email_admin_on_join']}<br />
<select name="email_admin_on_join">
{$email_admin_on_join_menu}</select><br /><br />
</label>
<label>{$LNG['a_s_email_admin_on_review']}<br />
<select name="email_admin_on_review">
{$email_admin_on_review_menu}</select><br /><br />
</label>
</fieldset>

<fieldset>
<legend>{$LNG['a_s_other']}</legend>
<label>{$LNG['a_s_search']}<br />
<select name="search">
{$search_menu}</select><br /><br />
</label>
<label>{$LNG['a_s_admin_password']} - {$LNG['edit_password_blank']}<br />
<input type="password" name="password" size="15" value="" /><br /><br />
</label>
<input name="submit" type="submit" value="{$LNG['a_s_header']}" />
</fieldset>
</form>
EndHTML;
  }

	function process() {
		global $CONF, $DB, $FORM, $LNG, $TMPL;

		$list_name = $DB->escape($FORM['list_name']);
		$list_url = $DB->escape($FORM['list_url']);
		$default_language = $DB->escape($FORM['default_language']);
		$your_email = $DB->escape($FORM['your_email']);

		$num_list = intval($FORM['num_list']);
		if ($num_list < 1) { $num_list = 1; } // Things get messed up if num_list is not a positive integer
		$ranking_period = $DB->escape($FORM['ranking_period']);
		$ranking_average = intval($FORM['ranking_average']);

		$active_default = intval($FORM['active_default']);
		$active_default_review = intval($FORM['active_default_review']);
		$delete_after = intval($FORM['delete_after']);
		$email_admin_on_join = intval($FORM['email_admin_on_join']);
		$email_admin_on_review = intval($FORM['email_admin_on_review']);

		$search = intval($FORM['search']);

		if(!empty($FORM['password'])) {
			$password = md5(md5($FORM['password']));
			mysql_unbuffered_query("UPDATE traffic_etc SET admin_password = '{$password}' LIMIT 1;");
		}

		mysql_unbuffered_query("UPDATE traffic_settings SET list_name = '{$list_name}', list_url = '{$list_url}', default_language = '{$default_language}', your_email = '{$your_email}',
							num_list = {$num_list}, ranking_period = '{$ranking_period}', ranking_average = {$ranking_average}, search = {$search},
							active_default = {$active_default}, active_default_review = {$active_default_review}, 
							delete_after = {$delete_after}, email_admin_on_join = {$email_admin_on_join}, email_admin_on_review = {$email_admin_on_review} LIMIT 1;");

		$TMPL['admin_content'] = $LNG['a_s_updated'];
	}
}
?>
