<?php
//=========================================================================================\\
// Copyright (C) WTStats.info, All rights reserved.	 http://www.wtstats.info			   \\
//=========================================================================================\\

if(!defined('ATSPHP')) {die('This file cannot be accessed directly.');}

class base {
	function error($message, $skin = 0) {
		global $TMPL;

		$TMPL['error'] = $message;
		if ($skin) {
			$TMPL["{$skin}_content"] = $this->do_skin('error');
			$TMPL['content'] = $this->do_skin($skin);
		} else {
			$TMPL['content'] = $this->do_skin('error');
		}

		$skin = new skin('wrapper');
		echo $skin->make();
		exit;
	}

	static function do_skin($filename) {
		$skin = new skin($filename);
		return $skin->make();
	}

	function rank_by($ranking_method = 0, $ranking_period = 0) {
		global $CONF;

		if(!$ranking_method) $ranking_method = $CONF['ranking_method'];
		if(!$ranking_period) $ranking_period = $CONF['ranking_period'];

		if ($ranking_period == 'overall') {
			$rank_by = "unq_{$ranking_method}_overall";
		} elseif (!$CONF['ranking_average']) {
			$rank_by = "unq_{$ranking_method}_0_{$ranking_period}";
		} else {
			$rank_by = '(';
			for ($i = 0; $i < 10; $i++) {
				$rank_by .= "unq_{$ranking_method}_{$i}_{$ranking_period} + ";
			}
			$rank_by .= "0) / 10";
		}

		return $rank_by;
	}

	function bad_words($text) {
		global $CONF;

		$result = mysql_query("SELECT word, replacement, matching FROM traffic_bad_words;");
		while (list($word, $replacement, $matching) = mysql_fetch_row($result)) {
			if ($matching) { // Exact matching
				$word = preg_quote($word);
				$text = preg_replace("/\b{$word}\b/i", $replacement, $text);
			} else { // Global matching
				$word = preg_quote($word);
				$text = str_ireplace($word, $replacement, $text);
			}
		}

		return $text;
	}
	
	function short_url($url) {
		if($url=='') return false;
		$url = parse_url($url, PHP_URL_HOST);
		$url = strtolower($url);
		$url = preg_replace('/^www\./', '', $url);
		return $url;
	}
	
	function getPage($url, $i=1) {
		if(ini_get('allow_url_fopen') && function_exists('file_get_contents')) {
			$response = file_get_contents($url);
		} elseif(extension_loaded('curl')) {
			$ch = curl_init();
			curl_setopt($ch, CURLOPT_URL, $url);
			curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
			curl_setopt($ch, CURLOPT_FAILONERROR, 1);
			curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 2);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			$response = curl_exec($ch);
			curl_close($ch);
		} 
		return !empty($response)?$response:($i<2?getPage($url,$i+1):false);
	}
}

class join_edit extends base {
	function check_input($type) {
		global $CONF, $FORM, $LNG, $TMPL;

		$error_username = 0;
		$error_username_duplicate = 0;
		$error_password = 0;
		$error_confirm_password = 0;
		$error_url = 0;
		$error_url_duplicate = 0;
		$error_email = 0;
		$error_title = 0;
		$error_captcha = 0;

		if ($type == 'join') {
			if (!preg_match('/^[a-zA-Z0-9\-_]{3,32}$/', $FORM['u'])) {$error_username = 1;}
			
			$query = mysql_fetch_row(mysql_query("SELECT username FROM traffic_sites WHERE username = '{$TMPL['username']}' LIMIT 1;"));
			if($query) {$error_username_duplicate = 1;}
			$query = mysql_fetch_row(mysql_query("SELECT url, short_url FROM traffic_sites WHERE url = '{$TMPL['url']}' OR short_url ='{$TMPL['short_url']}' LIMIT 1;"));
			if($query) {$error_url_duplicate = 1;}
			
			if(!$FORM['password']) {$error_password = 1;}
			if($FORM['password'] != $FORM['confirm_password']) {$error_confirm_password = 1;}
			
			$response = recaptcha_check_answer(PRIVATE_KEY, $_SERVER['REMOTE_ADDR'], $_POST['recaptcha_challenge_field'], $_POST['recaptcha_response_field']);
			if(!$response->is_valid) { $error_captcha = 1; }
		}
		if(!preg_match('/^https?:\/\/([-\w\.]+)+(:\d+)?(\/([\w\/_\.]*(\?\S+)?)?)?$/i', $TMPL['url']) || isset($TMPL['url'][64])) {$error_url = 1;}
		if(!preg_match('/^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,6}$/', $TMPL['email']) || isset($TMPL['email'][64])) {$error_email = 1;}
		if(empty($TMPL['title']) || isset($TMPL['title'][64])) {$error_title = 1;}

		if(!in_array($TMPL['category'], $CONF['categories'])) return 0;

		if ($error_username || $error_username_duplicate || $error_password || $error_confirm_password || $error_url || $error_url_duplicate || $error_email || $error_title || $error_captcha) {
			if ($error_username) {
				$TMPL['error_username'] = "<br />{$LNG['join_error_username']}";
				$TMPL['error_style_username'] = 'join_edit_error';
			}
			if ($error_username_duplicate) {
				$TMPL['error_username'] = "<br />{$LNG['join_error_username_duplicate']}";
				$TMPL['error_style_username'] = 'join_edit_error';
			}
			$TMPL['error_password'] = "<br />{$LNG['join_error_password']}";
			$TMPL['error_style_password'] = 'join_edit_error';
			if ($error_confirm_password) {
				$TMPL['error_password'] = "<br />{$LNG['join_error_confirm_password']}";
			}
			if ($error_url) {
				$TMPL['error_url'] .= "<br />{$LNG['join_error_url']}";
				$TMPL['error_style_url'] = 'join_edit_error';
			}
			if ($error_url_duplicate) {
				$TMPL['error_url'] = "<br />{$LNG['join_error_url_duplicate']}";
				$TMPL['error_style_url'] = 'join_edit_error';
			}
			if ($error_email) {
				$TMPL['error_email'] .= "<br />{$LNG['join_error_email']}";
				$TMPL['error_style_email'] = 'join_edit_error';
			}
			if ($error_title) {
				$TMPL['error_title'] .= "<br />{$LNG['join_error_title']}";
				$TMPL['error_style_title'] = 'join_edit_error';
			}
			$TMPL['error_style_captcha'] = 'join_edit_error';
			if ($error_captcha) {
				$TMPL['error_captcha'] .= "<br />{$LNG['join_error_captcha']}";
			}

			$TMPL['error_style_top'] = 'join_edit_error';
			$TMPL['error_top'] = $LNG['join_error_top'];

			return 0;
		} else {return 1;}
	}

	// This should be called before check_input
	function check_ban($type) {
		global $CONF, $FORM, $LNG, $TMPL;

		$ban_url = 0;
		$ban_email = 0;
		$ban_username = 0;
		$ban_ip = 0;

		if ($type == 'join') { $fields = array('url', 'email', 'username', 'ip'); }
		elseif ($type == 'edit') { $fields = array('url', 'email'); }
		elseif ($type == 'review') { $fields = array('ip'); }

		$TMPL['ip'] = $_SERVER['REMOTE_ADDR'];

		$result = mysql_query('SELECT id, string, field, matching FROM traffic_ban;');
		while (list($id, $string, $field, $matching) = mysql_fetch_row($result)) {
			if (in_array($field, $fields)) {
				$string = preg_quote($string);

				if ($matching) { $s = "^{$string}$"; } // Exact matching
				else { $s = $string; } // Global matching

				if(preg_match("|{$s}|", $TMPL[$field])) {$ban_url = 1;}
			}
		}

		if ($ban_url || $ban_email || $ban_username || $ban_ip) {
			$TMPL['error_style_top'] = 'join_edit_error';
			$TMPL['error_top'] = $LNG['join_ban_top'];

			return 0;
		} else {return 1;}
	}
}
?>
