<?php
//=========================================================================================\\
// Copyright (C) WTStats.info, All rights reserved.	 http://www.wtstats.info			   \\
//=========================================================================================\\

if(!defined('ATSPHP')) {die('This file cannot be accessed directly.');}

class stats extends base {
	function __construct() {
		global $FORM;

		if(isset($FORM['u'])) {$stats = new stats_site;} 
		else {$stats = new stats_overall;}
	}

	function averages() {
		global $TMPL;

		$ranking_periods = array('daily', 'weekly', 'monthly');
		$ranking_methods = array('unq_pv', 'tot_pv');
		foreach ($ranking_periods as $ranking_period) {
			foreach ($ranking_methods as $ranking_method) {
				$TMPL["{$ranking_method}_avg_{$ranking_period}"] = 0;
				for ($i = 0; $i < 10; $i++) {
					$TMPL["{$ranking_method}_avg_{$ranking_period}"] += $TMPL["{$ranking_method}_{$i}_{$ranking_period}"];
				}
				$TMPL["{$ranking_method}_avg_{$ranking_period}"] = number_format($TMPL["{$ranking_method}_avg_{$ranking_period}"] / 10, 1, '.', '');
			}
		}
	}

	function locale() {
		global $CONF, $LNG, $TMPL;

		setlocale(LC_ALL, $CONF['default_language']);
		for ($i = 2; $i < 10; $i++) {
			$TMPL["{$i}_daily"] = strftime('%B %d', time()-3600*24*$i);
		}
		for ($i = 2; $i < 10; $i++) {
			$TMPL["{$i}_weekly"] = "{$LNG['stats_week']} ".date('W', time()-3600*24*7*$i);
		}
		for ($i = 2; $i < 10; $i++) {
			$TMPL["{$i}_monthly"] = strftime('%B %y', mktime(0, 0, 0, date('m')-$i, 1));
		}
	}
	
	function procents($a, $b) {
		global $TMPL;
		$id2 = sprintf('%s_%s_%s_%s', $a, '%s', '%s', $b);
		$id  = sprintf($id2, 'pv', '%s');
		for($i = 8; $i >= 0; $i--) {
			$a = $TMPL[sprintf($id, $i)]; $b = $TMPL[sprintf($id, $i+1)];
			if($a>0&&$b>0) {
				$c = $a>$b?((1-$b/$a)*100):((1-$a/$b)*(-100));
				$c = number_format($c, 1, '.', '');
			} else {$c = 0;}
			$TMPL[sprintf($id2, 'p', $i)] = $c;
		}
	}
}

class stats_site extends stats {
	function __construct() {
		global $CONF, $DB, $FORM, $LNG, $TMPL;

		$TMPL['header'] = $LNG['stats_header'];

		$TMPL['username'] = $DB->escape($FORM['u'], 1);

		$stats = mysql_fetch_assoc(mysql_query("SELECT * FROM traffic_stats a JOIN traffic_sites b ON (a.id=b.id) WHERE b.username = '{$TMPL['username']}' LIMIT 1;"));
		if($stats) {
			$TMPL = array_merge($TMPL, $stats);
			
			$TMPL['unq_pv_max_daily']   = $TMPL['unq_pv_0_daily'] > $TMPL['unq_pv_max_daily'] ? $TMPL['unq_pv_0_daily'] : $TMPL['unq_pv_max_daily'];
			$TMPL['tot_pv_max_daily']   = $TMPL['tot_pv_0_daily'] > $TMPL['tot_pv_max_daily'] ? $TMPL['tot_pv_0_daily'] : $TMPL['tot_pv_max_daily'];
			$TMPL['unq_pv_max_weekly']  = $TMPL['unq_pv_0_weekly'] > $TMPL['unq_pv_max_weekly'] ? $TMPL['unq_pv_0_weekly'] : $TMPL['unq_pv_max_weekly'];
			$TMPL['tot_pv_max_weekly']  = $TMPL['tot_pv_0_weekly'] > $TMPL['tot_pv_max_weekly'] ? $TMPL['tot_pv_0_weekly'] : $TMPL['tot_pv_max_weekly'];
			$TMPL['unq_pv_max_monthly'] = $TMPL['unq_pv_0_monthly'] > $TMPL['unq_pv_max_monthly'] ? $TMPL['unq_pv_0_monthly'] : $TMPL['unq_pv_max_monthly'];
			$TMPL['tot_pv_max_monthly'] = $TMPL['tot_pv_0_monthly'] > $TMPL['tot_pv_max_monthly'] ? $TMPL['tot_pv_0_monthly'] : $TMPL['tot_pv_max_monthly'];
			
			$this->averages(); $this->locale();

			$TMPL['header'] .= " - {$TMPL['short_url']}";
			$TMPL['category_url'] = str_replace(' ', '+', $TMPL['category']);
			
			$TMPL['se'] = 'search.yahoo.com,alltheweb.com,ask.com,bing.com,search.aol.com,altavista.com,search.sweetim.com,search.conduit.com';
			
			$blocked = explode(',', $TMPL['blocked']);
			$result = mysql_query('SELECT `id`, `key`, `value`, `limit` FROM traffic_titles;');
			$titles = array(); $ids = array(); 
			while($row = mysql_fetch_row($result)) {
				$ids[$row[1]]    = $row[0];
				$titles[$row[1]] = $row[2];
				$limit[$row[1]]  = $row[3];
			}
			
			if(!empty($FORM['b']) && array_key_exists($FORM['b'], $titles)) {
				$f = $FORM['b'];
				$x = 'wts_'.str_replace('-', '_', $f);
				$shit = method_exists($this, $x)?call_user_func(array($this, $x), $limit[$f]):0;
				$TMPL['header'] .= " - {$titles[$f]}";
				$var = array('days' => 'daily', 'weeks' => 'weekly', 'months' => 'monthly');
				if(array_key_exists($f, $var)) {$this->procents('unq', $var[$f]); $this->procents('tot', $var[$f]);}
			} else {$f = 'stats';}
			
			$private = (isset($ids[$f])&&in_array($ids[$f],$blocked))||in_array('0',$blocked);
			if(!$private) {
				$TMPL['all'] = $this->do_skin("stats/$f");
				$TMPL['content'] = $this->do_skin('stats');
			} elseif(isset($_COOKIE['atsphp_sid_user_cp'])) {
				require_once("{$CONF['path']}/sources/misc/session.php");
				$session = new session;
				$user = $session->get($_COOKIE['atsphp_sid_user_cp']);
				if($user[1] == $TMPL['username']) {
					$TMPL['all'] = $this->do_skin("stats/$f");
					$TMPL['content'] = $this->do_skin('stats');
				} else {
					$TMPL['content'] = $this->do_skin('stats_hidden');
				}
			} else {
				$TMPL['content'] = $this->do_skin('stats_hidden');
			}
		} else {
			$this->error($LNG['g_invalid_u']);
		}
	}
	
	// Referreri
	function wts_referral($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_ref'] = $TMPL['web_refjs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			if($i < 5) $TMPL['web_refjs'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			$TMPL['web_ref'] .= "data.setValue({$i},0,'{$row[0]}');data.setValue({$i},1,{$row[1]});";
		}
		$TMPL['web_refc'] = $i;
		return 1;
	}
	
	// Trafic Retele de Socializare
	function wts_social($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer' AND (instr(text,'facebook.') > 0 OR instr(text,'twitter.') > 0) LIMIT 2;");
		$TMPL['web_rds'] = $TMPL['web_rdsc'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			$TMPL['web_rdsjs'] .= "data.setValue({$i},0,'{$row[0]}');data.setValue({$i},1,{$row[1]});";
			$TMPL['web_rds']   .= "data.setValue({$i},0,'{$row[0]}');data.setValue({$i},1,{$row[1]});";
		}
		$TMPL['web_rdsc'] = $i;
		return 1;
	}			
	
	// Motoare de cautare
	function wts_searchengines($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer' AND (instr('{$TMPL['se']}',text) > 0 OR instr(text,'google.') > 0) ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_br'] = $TMPL['web_brjs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			if($i < 5) $TMPL['web_mcjs'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			$TMPL['web_mc'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
		}
		$TMPL['web_mcc'] = $i;
		return 1;
	}
	
	//Cuvinte cheie
	function wts_keywords($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'keyword' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_key'] = $TMPL['web_keyjs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {		
			if($i < 5) $TMPL['web_keyjs'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			$key = urlencode($row[0]);
			$TMPL['web_key'] .= "data.setValue({$i}, 0, '<a href=\"{$list_url}/search/$key\">{$row[0]}</a>');data.setValue({$i}, 1, {$row[1]});\n";				
		}
		$TMPL['web_keyc'] = $i;
		return 1;
	}
	// Top Pagini
	function wts_top_pages($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'page' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_top'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			$page = htmlspecialchars(urldecode($row[0]), ENT_QUOTES);
			$url  = parse_url($page); $q = $url['query'];
			if(strlen($url['path']) > 1 && ($q == '' || strpos($q, '=') === false || strpos($q, 'rss') === true)) {
				$path = $url['path'];
				if(substr($path, -1, 1) != '/') {$path = pathinfo($path, PATHINFO_FILENAME);} 
				else {$path = array_reverse(explode('/', $path)); $path = $path[1];}
				$path = strlen($path)>4?$path:$url['path'];
				$path = preg_replace(array('/[^A-Za-z0-9]+/','/\s+/'), ' ', $path);
				$path = preg_replace(array('/^\s/','/\s$/'), '', $path);
				$path = ucwords($path);
			} else {
				$path = substr($page, strpos($page, $url['host']));
				$path = preg_replace('/\/+/', '/', $path);
			}
			$TMPL['web_topjs'] .= "data.setValue({$i}, 0, '{$page}');data.setValue({$i}, 1, {$row[1]});\n";
			$TMPL['web_top'] .= "data.setValue({$i}, 0, '<a href=\"{$page}\" rel=\"nofollow\">{$path}</a>');data.setValue({$i}, 1, {$row[1]});\n";
		}
		$TMPL['web_topc'] = $i;
		return 1;
	}
	// Tari
	function wts_countries($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'country' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_co'] = $TMPL['web_cojs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			list($country, $flag) = explode(':', $row[0]);
			$flag = "<img src=\"{$TMPL['list_url']}/images/flags/{$flag}.gif\" alt=\"{$flag}\">";
			$TMPL['web_cojs'] .= "data.setValue({$i}, 0, '{$country}');data.setValue({$i}, 1, {$row[1]});\n";
			$TMPL['web_co'] .= "data.setValue({$i}, 0, '{$flag} {$country}');data.setValue({$i}, 1, {$row[1]});\n";
		} 
		$TMPL['web_coc'] = $i;
		return 1;
	}
	
	// Browsere
	function wts_browsers($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'browser' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_br'] = $TMPL['web_brjs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			if($i < 5) $TMPL['web_brjs'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			$icon = '<img src="'.$TMPL['list_url'].'/images/icons/'.strtolower($row[0]).'.gif" alt="" />';
			$TMPL['web_br'] .= "data.setValue({$i}, 0, '{$icon} {$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			//$TMPL['web_brs'] .= "['{$row[0]}', {$row[1]}],\n";
		}
		$TMPL['web_brc'] = $i;
		return 1;
	} 
	
	// Sisteme de operare
	function wts_opersys($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'platform' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_os'] = $TMPL['web_osjs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			if($i < 5) $TMPL['web_osjs'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			$icon = "<img src=\"{$TMPL['list_url']}/images/icons/".strtolower($row[0]).".gif\" alt=\"{$row[0]}\">";
			$TMPL['web_os'] .= "data.setValue({$i}, 0, '{$icon} {$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
		}
		$TMPL['web_osc'] = $i;
		return 1;
	}
	
	// Rezolutii
	function wts_resolutions($limit) {
		global $TMPL;
		$result = mysql_query("SELECT text, count FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'resolution' ORDER BY 2 DESC LIMIT {$limit};");
		$TMPL['web_rez'] = $TMPL['web_rezjs'] = '';
		for($i = 0; ($row = mysql_fetch_row($result)) !== false; $i++) {
			if($i < 5) $TMPL['web_rezjs'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
			$TMPL['web_rez'] .= "data.setValue({$i}, 0, '{$row[0]}');data.setValue({$i}, 1, {$row[1]});\n";
		}
		$TMPL['web_rezc'] = $i;
		return 1;
	}
	
	// Directi vs. Referreri
	function wts_dvr($limit) {
		global $TMPL;
		$a = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer';")); $a = (int)$a[0];
		$t = mysql_fetch_row(mysql_query("SELECT SUM(unq_pv_overall) FROM traffic_stats WHERE id = {$TMPL['id']};")); $t = (int)$t[0];
		$b = $t-$a;
		$TMPL['web_dvr'] = "data.setValue(0, 0, 'Direct'); data.setValue(0, 1, {$b});\n";
		$TMPL['web_dvr'].= "data.setValue(1, 0, 'Referral'); data.setValue(1, 1, {$a});\n";
		$TMPL['web_dvrjs'] = $TMPL['web_dvr'];
		$TMPL['web_dvr'].= "data.setValue(2, 0, 'Total'); data.setValue(2, 1, {$t});\n";
		return 1;
	}
	
	// Motoare cautare vs. Referreri
	function wts_mvr($limit) {
		global $TMPL;
		$a = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer' AND (instr('{$TMPL['se']}',text) > 0 OR instr(text,'google.') > 0);")); $a = (int)$a[0];
		$t = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer';")); $t = (int)$t[0];
		$b = $t-$a;
		$TMPL['web_mvr'] = "data.setValue(0, 0, 'Referral'); data.setValue(0, 1, {$b});\n";
		$TMPL['web_mvr'].= "data.setValue(1, 0, 'Search engine'); data.setValue(1, 1, {$a});\n";
		$TMPL['web_mvrjs'] = $TMPL['web_mvr'];
		$TMPL['web_mvr'].= "data.setValue(2, 0, 'Total'); data.setValue(2, 1, {$t});\n";
		return 1;
	}
	
	// Directi vs. Referreri vs. Motoare cautare
	function wts_dvrvm($limit) {
		global $TMPL;
		$a = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer';")); $a = (int)$a[0];
		$t = mysql_fetch_row(mysql_query("SELECT SUM(unq_pv_overall) FROM traffic_stats WHERE id = {$TMPL['id']};")); $t = (int)$t[0];
		$b = $t-$a;
		$c = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'referer' AND (instr('{$TMPL['se']}',text) > 0 OR instr(text,'google.') > 0);")); $c = (int)$c[0];
		$a = $a-$c;
		$TMPL['web_txt'] = "data.setValue(0, 0, 'Direct'); data.setValue(0, 1, {$b});\n";
		$TMPL['web_txt'].= "data.setValue(1, 0, 'Referral'); data.setValue(1, 1, {$a});\n";
		$TMPL['web_txt'].= "data.setValue(2, 0, 'Search Engine'); data.setValue(2, 1, {$c});\n";
		$TMPL['web_js']  = $TMPL['web_txt'];
		$TMPL['web_txt'].= "data.setValue(3, 0, 'Total'); data.setValue(3, 1, {$t});\n";
		return 1;
	} 
	
	// Romani vs. Internationali
	function wts_rvi($limit) {
		global $TMPL;
		$a = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'country' AND text = 'Romania:ro';")); $a = (int)$a[0];
		$t = mysql_fetch_row(mysql_query("SELECT SUM(count) FROM traffic_details WHERE id = {$TMPL['id']} AND name = 'country';")); $t = (int)$t[0];
		$b = $t-$a;
		$TMPL['web_rvi'] = "data.setValue(0, 0, 'Romania'); data.setValue(0, 1, {$a});\n";
		$TMPL['web_rvi'].= "data.setValue(1, 0, 'International'); data.setValue(1, 1, {$b});\n";
		$TMPL['web_rvijs'] = $TMPL['web_rvi'];
		$TMPL['web_rvi'].= "data.setValue(2, 0, 'Total'); data.setValue(2, 1, {$t});\n";
		return 1;
	}
}

class stats_overall extends stats {
	function __construct() {
		global $CONF, $DB, $FORM, $LNG, $TMPL;

		$TMPL['header'] = $LNG['stats_overall'];

		$stats = mysql_fetch_assoc(mysql_query("SELECT SUM(unq_pv_overall), SUM(tot_pv_overall),
                         SUM(unq_pv_0_daily), SUM(unq_pv_1_daily), SUM(unq_pv_2_daily), SUM(unq_pv_3_daily), SUM(unq_pv_4_daily), SUM(unq_pv_5_daily), SUM(unq_pv_6_daily), SUM(unq_pv_7_daily), SUM(unq_pv_8_daily), SUM(unq_pv_9_daily), SUM(tot_pv_0_daily), SUM(tot_pv_1_daily), SUM(tot_pv_2_daily), SUM(tot_pv_3_daily), SUM(tot_pv_4_daily), SUM(tot_pv_5_daily), SUM(tot_pv_6_daily), SUM(tot_pv_7_daily), SUM(tot_pv_8_daily), SUM(tot_pv_9_daily),
                         SUM(unq_pv_0_weekly), SUM(unq_pv_1_weekly), SUM(unq_pv_2_weekly), SUM(unq_pv_3_weekly), SUM(unq_pv_4_weekly), SUM(unq_pv_5_weekly), SUM(unq_pv_6_weekly), SUM(unq_pv_7_weekly), SUM(unq_pv_8_weekly), SUM(unq_pv_9_weekly), SUM(tot_pv_0_weekly), SUM(tot_pv_1_weekly), SUM(tot_pv_2_weekly), SUM(tot_pv_3_weekly), SUM(tot_pv_4_weekly), SUM(tot_pv_5_weekly), SUM(tot_pv_6_weekly), SUM(tot_pv_7_weekly), SUM(tot_pv_8_weekly), SUM(tot_pv_9_weekly),
                         SUM(unq_pv_0_monthly), SUM(unq_pv_1_monthly), SUM(unq_pv_2_monthly), SUM(unq_pv_3_monthly), SUM(unq_pv_4_monthly), SUM(unq_pv_5_monthly), SUM(unq_pv_6_monthly), SUM(unq_pv_7_monthly), SUM(unq_pv_8_monthly), SUM(unq_pv_9_monthly), SUM(tot_pv_0_monthly), SUM(tot_pv_1_monthly), SUM(tot_pv_2_monthly), SUM(tot_pv_3_monthly), SUM(tot_pv_4_monthly), SUM(tot_pv_5_monthly), SUM(tot_pv_6_monthly), SUM(tot_pv_7_monthly), SUM(tot_pv_8_monthly), SUM(tot_pv_9_monthly)
                         FROM traffic_stats;"));

		// Get rid of SUM() in array keys
		foreach ($stats as $key => $value) {
			$new_key = str_replace(array('SUM(', ')'), '', $key);
			$stats[$new_key] = $value;
			unset($stats[$key]);
		}

		$TMPL = array_merge($TMPL, $stats);

		$this->averages();

		$stats = array_map('floatval', $stats);
		$TMPL = array_merge($TMPL, $stats);

		$this->locale();

		$TMPL['content'] = $this->do_skin('stats_overall');
	}
}
?>